/* lib/browser.p
 *
 * generic data browser setup
 *
 * protop.p runs this to initialize UI
 *
 */

{lib/dynscreen.i}

define input parameter dispOrder as integer   no-undo.
define input parameter scrTitle  as character no-undo.
define input parameter dcName    as character no-undo.
define input parameter ttName    as character no-undo.
define input parameter minRows   as integer   no-undo.
define input parameter maxRows   as integer   no-undo.
define input parameter keyCmd    as character no-undo.

define variable f as handle no-undo.

create widget-pool.

/* setup
 *
 */

/* if changes are made to formatting in dc/latch.p, dc/resrc.p, or dc/txe.p the column offsets below may need to change */

create frame f.
assign
  f:row          = 3					/* the actual rendering will (probably) modify this			*/
  f:height-chars = 1					/* the actual rendering will (probably) modify this			*/
  f:column       = 1
  f:width-chars  = ( if session:window-system <> "tty" then 160 else 255 )
  f:box          = no
  f:top-only     = false
  f:overlay      = true
  f:name         = ttName
  f:private-data = scrTitle
  f:sensitive    = no
  f:visible      = no
  f:hidden       = yes
.

if session:window-system <> "tty" then
  assign
    f:height-chars = 1
    f:scrollable   = false
  .

/* latches, resources, and txe are a bit special
 */

if session:batch = no and current-window:width-chars >= 160 then
  do:

    if dcName = "LatchActivity" then
      assign
        f:column       =  1
        f:width-chars  = 55
      .
     else if dcName = "ResourceWaits" then
      assign
        f:column       = 57
        f:width-chars  = 42
      .
     else if dcName = "TXE" then
      assign
        f:column       = 101
        f:width-chars  = 58
      .

  end.
 else
  do:

    if dcName = "LatchActivity" then
      assign
        f:column       =  1
        f:width-chars  = 38
      .
     else if dcName = "ResourceWaits" then
      assign
        f:column       = 40
        f:width-chars  = 38
      .
     else if dcName = "TXE" then
      assign
        f:column       = 81
        f:width-chars  = 38
      .

  end.

run dynBrowserInit( f, dcName, ttName, dispOrder, minRows, ( if maxRows <= 0 then maxRows else maxRows + 2 /* 5 +++ */ ), keyCmd ).

/* initialize
 *
 */

publish "protop_register" ( dcName ).

return.
